class Literal {
	int polarity;
	Term atom;
	
	public Literal() {
	}
	
	public Literal(int p, Term P) {
		polarity = p;
		atom = P.duplicate();
	}

	public String toString() {
		if (polarity < 0) {
			return "-" + atom;
		}
		return "" + atom;
	}

	boolean complementary(Literal l) {
		if (atom.equals(l.atom) && polarity * l.polarity < 0) {
			return true;
		}
		return false;
	}

	boolean equals(Literal l) {
		if (this.atom.equals(l.atom) && this.polarity * l.polarity > 0) {
			return true;
		}
		return false;
	}
	
	Literal duplicate() {
		Literal L = new Literal();
		L.polarity = this.polarity;
		L.atom = this.atom.duplicate();
		return L;
	}

	Literal substitute(Sbst sbst) {
		Literal L = new Literal();
		L = this.duplicate();
		L.atom = L.atom.substitute(sbst);
		return L;
	}

	Literal substituteAtOnce(SbstSet sset) {
		Literal L = new Literal();
		L = this.duplicate();
		L.atom = L.atom.substituteAtOnce(sset);
		return L;
	}
}
