import java.util.*;
class SbstSet {
	ArrayList<Sbst> sbsts;
	int size;
	
	public SbstSet() {
		sbsts = new ArrayList<Sbst>();
		size = 0;
	}
	
	public String toString() {
		String s = "";
		for (int i = 0; i < this.size; i++) {
			s += this.get(i) + ", ";
		}
		if (s.length() > 2) {
			s = s.substring(0, s.length() - 2);
		}
		return "{ " + s + " }";
	}
	
	boolean consistentWith(Sbst sbst) {
		for (int i = 0; i < this.size; i++) {
			if (!this.get(i).consistentWith(sbst)) {
				return false;
			}
		}
		return true;
	}
	
	void add(Sbst sbst) {
		int n = 0;
		for (int i = 0; i < this.size; i++) {
			if (this.get(i).variable.equals(sbst.variable)) {
				n = 1;
				break;
			}
		}
		if (n == 0) {
			this.sbsts.add(sbst.duplicate());
			size++;
		}
	}
	
	void remove(Sbst sbst) {
		this.sbsts.remove(sbst);
		size--;
	}
	
	Sbst get(int n) {
		return this.sbsts.get(n);
	}
	
	SbstSet union(SbstSet sset) {
		SbstSet sset2 = new SbstSet();
		for (int i = 0; i < this.size; i++) {
			sset2.add(this.get(i).duplicate());
		}
		for (int i = 0; i < sset.size; i++) {
			sset2.add(sset.get(i).duplicate());
		}
		return sset2;
	}
	
	SbstSet composite(SbstSet sset) {
		SbstSet comp = new SbstSet();
		for (Sbst sbst : this.sbsts) {
			Sbst s = new Sbst();
			s.term = sbst.term.duplicate().substituteAtOnce(sset);
			s.variable = sbst.variable.duplicate();
			comp.add(s);
		}
		comp = comp.union(sset);
		return comp;
	}

	SbstSet composite(Sbst ss) {
		SbstSet comp = new SbstSet();
		for (Sbst sbst : this.sbsts) {
			Sbst s = new Sbst();
			s.term = sbst.term.duplicate().substitute(ss);
			s.variable = sbst.variable.duplicate();
			comp.add(s);
		}
		comp.add(ss);
		return comp;
	}

	
	boolean contains(Sbst sbst) {
		for (Sbst s : this.sbsts) {
			if (s.equals(sbst)) {
				return true;
			}
		}
		return false;
	}
	
	boolean isEmpty() {
		if (this.sbsts.isEmpty()) {
			return true;
		}
		return false;
	}
	
	boolean subSet(SbstSet sset) {
		for (Sbst sbst : this.sbsts) {
			if (!sset.contains(sbst)) {
				return false;
			}
		}
		return true;
	}
	
	boolean equals(SbstSet sset) {
		if (this.subSet(sset) && sset.subSet(this)) {
			return true;
		}
		return false;
	}
	
	void avoidVariableClash() {
		for (int i = 0; i < this.size; i++) {
			this.get(i).avoidVariableClash();
		}
	}
	
	void undoAvoidVariableClash() {
		for (int i = 0; i < this.size; i++) {
			this.get(i).undoAvoidVariableClash();
		}
	}

	
	public static void main(String[] args) {
	}
}
